#include "scsk.h"

#include <glt/gl.h>
#include <glt/error.h>
#include <glt/countsrf.h>

#include <node/shapes.h>

#include <csg/element.h>
#include <csg/options.h>
#include <csg/info.h>

#include <iostream>
using namespace std;

//#define DEBUG_SCS

#if defined(NDEBUG) && defined(DEBUG_SCS)
#undef DEBUG_SCS
#endif

int csgSampleK
(
    const CsgProduct &product,
    const CsgOptions &options,
          CsgInfo    &info
)
{
    // Find k

    GltShapes shapes;
    for (GLuint i=0; i<product.size(); i++)
        shapes.push_back(product.shape(i));

    if (options.cullFaces)
        glEnable(GL_CULL_FACE);
    else
        glDisable(GL_CULL_FACE);

    const GLuint count = countSurfaces(shapes,COUNT_SURFACES_ALL);

    #ifdef DEBUG_SCS
    cout << "csgSampleK: " << count << endl;
    #endif

    return (options.cullFaces ? count : count>>1);
}

int csgSampleK
(
    const CsgSubtractionSequence &objects,
    const CsgProduct             &product,
    const CsgOptions             &options,
          CsgInfo                &info
)
{
    // Find k

    GltShapes shapes;
    for (GLuint i=0; i<objects.size(); i++)
        shapes.push_back(product.shape(objects[i]));

    if (options.cullFaces)
        glEnable(GL_CULL_FACE);
    else
        glDisable(GL_CULL_FACE);

    const GLuint count = countSurfaces(shapes,COUNT_SURFACES_ALL);

    #ifdef DEBUG_SCS
    cout << "csgSampleK: " << count << endl;
    #endif

    return (options.cullFaces ? count : count>>1);
}

